<template>
  <div
    :id="currentPage"
    class="dibs-wrapper"
    :data-layout="layout"
    :data-alternate="alternate"
  >
    <loading
      :active.sync="isLoading"
      :is-full-page="true"
      color="var(--dibs-colors--red)"
    />
    <div v-if="withNavbar && user" class="dibs--navbar">
      <router-link class="dibs--navbar--logo" :to="localePath('/')">
        <dibs-img alt="e-rentes.ch" file="logos/e-rentes.ch.png" />
      </router-link>
      <div class="dibs--navbar--links">
        <div
          v-if="currentPage == 'synthesis' || withSynthesisLink"
          class="dibs--navbar--synthesis"
          :data-always-on="currentPage == 'synthesis'"
          @click="$router.push(localePath('/synthesis'))"
        >
          <div class="dibs--navbar--synthesis--text">
            <dibs-picto-calc />
            <span>{{ $t('commons.my_synthesis') }}</span>
          </div>
          <div class="dibs--navbar--synthesis--picto">
            <svg
              viewBox="0 0 18 9"
              fill="none"
              xmlns="http://www.w3.org/2000/svg"
            >
              <path d="M9 9L0 0H18L9 9Z" />
            </svg>
          </div>
        </div>
        <div class="dibs--navbar--user">
          <img
            v-if="userInfo.avatar"
            class="dibs--navbar--user--avatar"
            :src="userInfo.avatar"
          />
          <div class="dibs--navbar--user--initial">
            <span>{{ userInfo.initial }}</span>
          </div>
          <div class="dibs--navbar--user--menu--wrapper">
            <div class="dibs--navbar--user--menu">
              <a
                class="dibs--navbar--user--menu--item"
                :href="$config.dibsApiBasePath + '/login/disconnect'"
              >
                {{ $t('commons.disconnect') }}
              </a>
              <a
                class="dibs--navbar--user--menu--item"
                :href="$config.dibsApiBasePath + '/login/reset'"
              >
                {{ $t('commons.reset') }}
              </a>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="dibs--aside">
      <slot name="aside">
        <div class="dibs--aside--content">
          <div class="dibs--aside--content--header">
            <slot name="aside-header"></slot>
          </div>
          <div class="dibs--aside--title">
            <slot name="aside-title"></slot>
          </div>
          <slot name="aside-content"></slot>
        </div>
        <dibs-elem-video v-if="video" :src="video.src" :title="video.title" />
      </slot>
    </div>
    <div class="dibs--main">
      <div class="dibs--main--content">
        <slot name="content"></slot>
      </div>
    </div>
  </div>
</template>
<script>
import { mapMutations } from 'vuex'
import Loading from 'vue-loading-overlay'
import { createSidetab } from '@typeform/embed'
export default {
  components: { Loading },
  props: {
    video: {
      type: [Object],
      required: false,
      default: () => {
        return null
      },
    },
    layout: {
      type: [String],
      required: true,
      validator(value) {
        // The value must match one of these strings
        return ['one-column', 'two-columns', 'hidden', 'export'].includes(value)
      },
    },
    withNavbar: {
      type: [Boolean],
      required: false,
      default: true,
    },
    page: {
      type: [String],
      required: false,
      default: '',
    },
    alternate: {
      type: [Boolean],
      required: false,
      default: false,
    },
  },
  data() {
    return {
      loadings: 1,
      isModalOpened: false,
      currentPage: this.page,
      User: this.$models.User(),
      Modals: this.$models.Modals(),
      withSynthesisLink: false,
      currentEmail: 'none',
      typeformToggler: null,
      typeformCloseTimeout: null,
    }
  },
  head() {
    return {
      bodyAttrs: {
        'data-modal-is-open': this.isModalOpened,
        'data-layout': this.layout,
      },
    }
  },
  computed: {
    isLoading() {
      return this.loadings > 0
    },
    user() {
      return this.$store.state.user.login
    },
    userInfo() {
      if (!this.user) {
        return null
      }

      const initial = this.user.name.substring(0, 2).toUpperCase()
      const avatar = this.user.picture
      return {
        initial,
        avatar,
      }
    },
  },
  watch: {
    isModalOpened(isModalOpened) {
      const bodyElement = document.querySelector('body')
      bodyElement.dataset.modalIsOpen = isModalOpened
    },
  },
  async mounted() {
    this.$models.Loader().onOn(() => {
      this.incrementLoading(+1)
    })
    this.$models.Loader().onOff(() => {
      this.incrementLoading(-1)
    })
    this.User.onCheckConnectionStatus(this.checkIfConnected, 'once')
    this.Modals.onIsOpen(() => {
      this.isModalOpened = true
    })
    this.Modals.onIsClosed(() => {
      this.isModalOpened = false
    })

    if (this.withNavbar) {
      await this.loadMe()
    } else {
      this.incrementLoading(-1)
    }

    this.typeformToggler = this.initTypeform(
      this.currentPage,
      this.currentEmail
    )
  },
  beforeDestroy() {
    if (this.typeformToggler) {
      this.typeformToggler.close()
      this.typeformToggler.unmount()
    }
  },
  methods: {
    ...mapMutations({
      setUser: 'user/setLogin',
      emptyUser: 'user/emptyLogin',
    }),
    _getMe(force = false) {
      return this.User.getMe(force)
    },
    loadMe(force = false) {
      return this._getMe(force)
        .then((data) => {
          this.currentEmail = data.email
          this.setUser(data)
          this.User.emitIsConnected()
          this.withSynthesisLink = false
          this.$models
            .OpenAK()
            .get()
            .then(() => {
              this.withSynthesisLink = true
            })
        })
        .catch(() => {
          this.emptyUser()
        })
        .finally(() => {
          this.incrementLoading(-1)
          this.User.emitLoadedOnce()
        })
    },
    incrementLoading(value) {
      this.loadings += value
    },
    cleanup() {
      this.$eventBus.$off()
      this.emptyUser()
      this.$router.push(this.localePath('/'))
    },
    checkIfConnected() {
      if (this.isLoading) {
        this.User.onLoadedOnce(() => {
          if (!this.user) {
            this.cleanup()
          }
        })
      } else {
        return this._getMe()
          .then(() => {
            this.User.emitIsConnected()
          })
          .catch(() => {
            this.cleanup()
          })
      }
    },
    initTypeform(page, email) {
      if (page === 'export') {
        return null
      }

      let formId = this.$t('commons.sondage')
      if (page === 'synthesis') {
        formId = this.$t('commons.sondage_synthesis')
      }

      return createSidetab(formId, {
        position: 'right',
        buttonColor: '#D92E30',
        buttonText: this.$t('commons.sondage_button'),
        hidden: {
          page,
          email,
        },
        onQuestionChanged: ({ formId, ref }) => {
          if (ref === 'fake-end') {
            this.typeformCloseTimeout = setTimeout(() => {
              this.typeformToggler.close()
            }, 2000)
          } else {
            clearTimeout(this.typeformCloseTimeout)
            this.typeformCloseTimeout = null
          }
        },
      })
    },
  },
}
</script>
<style></style>
